<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
<!-- qmlerror.cpp -->
  <title>QmlError Class | Extending Qt Creator Manual</title>
  <link rel="stylesheet" type="text/css" href="style/offline-simple.css" />
  <script type="text/javascript">
    document.getElementsByTagName("link").item(0).setAttribute("href", "style/offline.css");
    // loading style sheet breaks anchors that were jumped to before
    // so force jumping to anchor again
    setTimeout(function() {
        var anchor = location.hash;
        // need to jump to different anchor first (e.g. none)
        location.hash = "#";
        setTimeout(function() {
            location.hash = anchor;
        }, 0);
    }, 0);
  </script>
</head>
<body>
<div class="header" id="qtdocheader">
  <div class="main">
    <div class="main-rounded">
      <div class="navigationbar">
        <table><tr>
<td ><a href="extending-index.html">Extending Qt Creator Manual</a></td><td >QmlError</td></tr></table><table class="buildversion"><tr>
<td id="buildversion" width="100%" align="right"><a href="extending-index.html">Extending Qt Creator Manual 4.11.1</a></td>
        </tr></table>
      </div>
    </div>
<div class="content">
<div class="line">
<div class="content mainContent">
<div class="sidebar">
<div class="toc">
<h3><a name="toc">Contents</a></h3>
<ul>
<li class="level1"><a href="#public-functions">Public Functions</a></li>
<li class="level1"><a href="#related-non-members">Related Non-Members</a></li>
<li class="level1"><a href="#details">Detailed Description</a></li>
</ul>
</div>
<div class="sidebar-content" id="sidebar-content"></div></div>
<h1 class="title">QmlError Class</h1>
<!-- $$$QmlError-brief -->
<p>The QmlError class encapsulates a QML error. <a href="#details">More...</a></p>
<!-- @@@QmlError -->
<div class="table"><table class="alignedsummary">
<tr><td class="memItemLeft rightAlign topAlign"> Header:</td><td class="memItemRight bottomAlign">   <span class="preprocessor">#include &lt;QmlError&gt;</span>
</td></tr><tr><td class="memItemLeft rightAlign topAlign"> Since:</td><td class="memItemRight bottomAlign"> Qt 5.0</td></tr></table></div><p>This class was introduced in Qt 5.0.</p>
<ul>
<li><a href="qmlerror-members.html">List of all members, including inherited members</a></li>
</ul>
<a name="public-functions"></a>
<h2 id="public-functions">Public Functions</h2>
<div class="table"><table class="alignedsummary">
<tr><td class="memItemLeft rightAlign topAlign"> </td><td class="memItemRight bottomAlign"><b><a href="qmlerror.html#QmlError-1">QmlError</a></b>(const QmlError &amp;<i>other</i>)</td></tr>
<tr><td class="memItemLeft rightAlign topAlign"> </td><td class="memItemRight bottomAlign"><b><a href="qmlerror.html#QmlError">QmlError</a></b>()</td></tr>
<tr><td class="memItemLeft rightAlign topAlign"> QmlError &amp;</td><td class="memItemRight bottomAlign"><b><a href="qmlerror.html#operator-eq">operator=</a></b>(const QmlError &amp;<i>other</i>)</td></tr>
<tr><td class="memItemLeft rightAlign topAlign"> int </td><td class="memItemRight bottomAlign"><b><a href="qmlerror.html#column">column</a></b>() const</td></tr>
<tr><td class="memItemLeft rightAlign topAlign"> QString </td><td class="memItemRight bottomAlign"><b><a href="qmlerror.html#description">description</a></b>() const</td></tr>
<tr><td class="memItemLeft rightAlign topAlign"> bool </td><td class="memItemRight bottomAlign"><b><a href="qmlerror.html#isValid">isValid</a></b>() const</td></tr>
<tr><td class="memItemLeft rightAlign topAlign"> int </td><td class="memItemRight bottomAlign"><b><a href="qmlerror.html#line">line</a></b>() const</td></tr>
<tr><td class="memItemLeft rightAlign topAlign"> int </td><td class="memItemRight bottomAlign"><b><a href="qmlerror.html#messageType">messageType</a></b>() const</td></tr>
<tr><td class="memItemLeft rightAlign topAlign"> QObject *</td><td class="memItemRight bottomAlign"><b><a href="qmlerror.html#object">object</a></b>() const</td></tr>
<tr><td class="memItemLeft rightAlign topAlign"> void </td><td class="memItemRight bottomAlign"><b><a href="qmlerror.html#setColumn">setColumn</a></b>(int <i>column</i>)</td></tr>
<tr><td class="memItemLeft rightAlign topAlign"> void </td><td class="memItemRight bottomAlign"><b><a href="qmlerror.html#setDescription">setDescription</a></b>(const QString &amp;<i>description</i>)</td></tr>
<tr><td class="memItemLeft rightAlign topAlign"> void </td><td class="memItemRight bottomAlign"><b><a href="qmlerror.html#setLine">setLine</a></b>(int <i>line</i>)</td></tr>
<tr><td class="memItemLeft rightAlign topAlign"> void </td><td class="memItemRight bottomAlign"><b><a href="qmlerror.html#setMessageType">setMessageType</a></b>(int <i>messageType</i>)</td></tr>
<tr><td class="memItemLeft rightAlign topAlign"> void </td><td class="memItemRight bottomAlign"><b><a href="qmlerror.html#setObject">setObject</a></b>(QObject *<i>object</i>)</td></tr>
<tr><td class="memItemLeft rightAlign topAlign"> QString </td><td class="memItemRight bottomAlign"><b><a href="qmlerror.html#toString">toString</a></b>() const</td></tr>
<tr><td class="memItemLeft rightAlign topAlign"> int </td><td class="memItemRight bottomAlign"><b><a href="qmlerror.html#url">url</a></b>() const</td></tr>
</table></div>
<a name="related-non-members"></a>
<h2 id="related-non-members">Related Non-Members</h2>
<div class="table"><table class="alignedsummary">
<tr><td class="memItemLeft rightAlign topAlign"> QDebug </td><td class="memItemRight bottomAlign"><b><a href="qmlerror.html#operator-lt-lt">operator&lt;&lt;</a></b>(QDebug <i>debug</i>, const QmlError &amp;<i>error</i>)</td></tr>
</table></div>
<a name="details"></a>
<!-- $$$QmlError-description -->
<div class="descr">
<h2 id="details">Detailed Description</h2>
<p>QmlError includes a textual description of the error, as well as location information (the file, line, and column). The <a href="qmlerror.html#toString">toString</a>() method creates a single-line, human-readable string containing all of this information, for example:</p>
<pre class="cpp">

  file:<span class="comment">///home/user/test.qml:7:8: Invalid property assignment: double expected</span>

</pre>
<p>You can use <a href="http://doc.qt.io/qt-5/qtglobal.html#qDebug">qDebug</a>(), <a href="http://doc.qt.io/qt-5/qtglobal.html#qInfo">qInfo</a>(), or <a href="http://doc.qt.io/qt-5/qtglobal.html#qWarning">qWarning</a>() to output errors to the console. This method will attempt to open the file indicated by the error and include additional contextual information.</p>
<pre class="cpp">

  file:<span class="comment">///home/user/test.qml:7:8: Invalid property assignment: double expected</span>
          y: <span class="string">&quot;hello&quot;</span>
             <span class="operator">^</span>

</pre>
<p>Note that the <a href="http://doc.qt.io/qt-5/qtquick-porting-qt5.html">Qt Quick 1</a> version is named QDeclarativeError</p>
</div>
<p><b>See also </b><a href="http://doc.qt.io/qt-5/qquickview.html#errors">QQuickView::errors</a>() and QmlComponent::errors().</p>
<!-- @@@QmlError -->
<div class="func">
<h2>Member Function Documentation</h2>
<!-- $$$QmlError$$$QmlErrorconstQmlError& -->
<h3 class="fn" id="QmlError-1"><a name="QmlError-1"></a>QmlError::<span class="name">QmlError</span>(const <span class="type"><a href="qmlerror.html#QmlError">QmlError</a></span> &amp;<i>other</i>)</h3>
<p>Creates a copy of <i>other</i>.</p>
<!-- @@@QmlError -->
<!-- $$$QmlError[overload1]$$$QmlError -->
<h3 class="fn" id="QmlError"><a name="QmlError"></a>QmlError::<span class="name">QmlError</span>()</h3>
<p>Creates an empty error object.</p>
<!-- @@@QmlError -->
<!-- $$$operator=[overload1]$$$operator=constQmlError& -->
<h3 class="fn" id="operator-eq"><a name="operator-eq"></a><span class="type"><a href="qmlerror.html#QmlError">QmlError</a></span> &amp;QmlError::<span class="name">operator=</span>(const <span class="type"><a href="qmlerror.html#QmlError">QmlError</a></span> &amp;<i>other</i>)</h3>
<p>Assigns <i>other</i> to this error object.</p>
<!-- @@@operator= -->
<!-- $$$column[overload1]$$$column -->
<h3 class="fn" id="column"><a name="column"></a><span class="type">int</span> QmlError::<span class="name">column</span>() const</h3>
<p>Returns the error column number.</p>
<p><b>See also </b><a href="qmlerror.html#setColumn">setColumn</a>().</p>
<!-- @@@column -->
<!-- $$$description[overload1]$$$description -->
<h3 class="fn" id="description"><a name="description"></a><span class="type"><a href="http://doc.qt.io/qt-5/qstring.html">QString</a></span> QmlError::<span class="name">description</span>() const</h3>
<p>Returns the error description.</p>
<p><b>See also </b><a href="qmlerror.html#setDescription">setDescription</a>().</p>
<!-- @@@description -->
<!-- $$$isValid[overload1]$$$isValid -->
<h3 class="fn" id="isValid"><a name="isValid"></a><span class="type">bool</span> QmlError::<span class="name">isValid</span>() const</h3>
<p>Returns true if this error is valid, otherwise false.</p>
<!-- @@@isValid -->
<!-- $$$line[overload1]$$$line -->
<h3 class="fn" id="line"><a name="line"></a><span class="type">int</span> QmlError::<span class="name">line</span>() const</h3>
<p>Returns the error line number.</p>
<p><b>See also </b><a href="qmlerror.html#setLine">setLine</a>().</p>
<!-- @@@line -->
<!-- $$$messageType[overload1]$$$messageType -->
<h3 class="fn" id="messageType"><a name="messageType"></a><span class="type">int</span> QmlError::<span class="name">messageType</span>() const</h3>
<p>Returns the message type.</p>
<p>This function was introduced in Qt 5.9.</p>
<p><b>See also </b><a href="qmlerror.html#setMessageType">setMessageType</a>().</p>
<!-- @@@messageType -->
<!-- $$$object[overload1]$$$object -->
<h3 class="fn" id="object"><a name="object"></a><span class="type"><a href="http://doc.qt.io/qt-5/qobject.html">QObject</a></span> *QmlError::<span class="name">object</span>() const</h3>
<p>Returns the nearest object where this error occurred. Exceptions in bound property expressions set this to the object to which the property belongs. It will be 0 for all other exceptions.</p>
<p><b>See also </b><a href="qmlerror.html#setObject">setObject</a>().</p>
<!-- @@@object -->
<!-- $$$setColumn[overload1]$$$setColumnint -->
<h3 class="fn" id="setColumn"><a name="setColumn"></a><span class="type">void</span> QmlError::<span class="name">setColumn</span>(<span class="type">int</span> <i>column</i>)</h3>
<p>Sets the error <i>column</i> number.</p>
<p><b>See also </b><a href="qmlerror.html#column">column</a>().</p>
<!-- @@@setColumn -->
<!-- $$$setDescription[overload1]$$$setDescriptionconstQString& -->
<h3 class="fn" id="setDescription"><a name="setDescription"></a><span class="type">void</span> QmlError::<span class="name">setDescription</span>(const <span class="type"><a href="http://doc.qt.io/qt-5/qstring.html">QString</a></span> &amp;<i>description</i>)</h3>
<p>Sets the error <i>description</i>.</p>
<p><b>See also </b><a href="qmlerror.html#description">description</a>().</p>
<!-- @@@setDescription -->
<!-- $$$setLine[overload1]$$$setLineint -->
<h3 class="fn" id="setLine"><a name="setLine"></a><span class="type">void</span> QmlError::<span class="name">setLine</span>(<span class="type">int</span> <i>line</i>)</h3>
<p>Sets the error <i>line</i> number.</p>
<p><b>See also </b><a href="qmlerror.html#line">line</a>().</p>
<!-- @@@setLine -->
<!-- $$$setMessageType[overload1]$$$setMessageTypeint -->
<h3 class="fn" id="setMessageType"><a name="setMessageType"></a><span class="type">void</span> QmlError::<span class="name">setMessageType</span>(<span class="type">int</span> <i>messageType</i>)</h3>
<p>Sets the <i>messageType</i> for this message. The message type determines which <a href="http://doc.qt.io/qt-5/qdebug.html">QDebug</a> handlers are responsible for receiving the message.</p>
<p>This function was introduced in Qt 5.9.</p>
<p><b>See also </b><a href="qmlerror.html#messageType">messageType</a>().</p>
<!-- @@@setMessageType -->
<!-- $$$setObject[overload1]$$$setObjectQObject* -->
<h3 class="fn" id="setObject"><a name="setObject"></a><span class="type">void</span> QmlError::<span class="name">setObject</span>(<span class="type"><a href="http://doc.qt.io/qt-5/qobject.html">QObject</a></span> *<i>object</i>)</h3>
<p>Sets the nearest <i>object</i> where this error occurred.</p>
<p><b>See also </b><a href="qmlerror.html#object">object</a>().</p>
<!-- @@@setObject -->
<!-- $$$toString[overload1]$$$toString -->
<h3 class="fn" id="toString"><a name="toString"></a><span class="type"><a href="http://doc.qt.io/qt-5/qstring.html">QString</a></span> QmlError::<span class="name">toString</span>() const</h3>
<p>Returns the error as a human readable string.</p>
<!-- @@@toString -->
<!-- $$$url[overload1]$$$url -->
<h3 class="fn" id="url"><a name="url"></a><span class="type">int</span> QmlError::<span class="name">url</span>() const</h3>
<p>Returns the url for the file that caused this error.</p>
<!-- @@@url -->
</div>
<div class="relnonmem">
<h2>Related Non-Members</h2>
<!-- $$$operator<<[overload1]$$$operator<<QDebugconstQmlError& -->
<h3 class="fn" id="operator-lt-lt"><a name="operator-lt-lt"></a><span class="type"><a href="http://doc.qt.io/qt-5/qdebug.html">QDebug</a></span> <span class="name">operator&lt;&lt;</span>(<span class="type"><a href="http://doc.qt.io/qt-5/qdebug.html">QDebug</a></span> <i>debug</i>, const <span class="type"><a href="qmlerror.html#QmlError">QmlError</a></span> &amp;<i>error</i>)</h3>
<p>Outputs a human readable version of <i>error</i> to <i>debug</i>.</p>
<!-- @@@operator<< -->
</div>
        </div>
       </div>
   </div>
   </div>
</div>
<div class="footer">
   <p>
   <acronym title="Copyright">&copy;</acronym> 2020 The Qt Company Ltd.
   Documentation contributions included herein are the copyrights of
   their respective owners.<br/>    The documentation provided herein is licensed under the terms of the    <a href="http://www.gnu.org/licenses/fdl.html">GNU Free Documentation    License version 1.3</a> as published by the Free Software Foundation.<br/>    Qt and respective logos are trademarks of The Qt Company Ltd.     in Finland and/or other countries worldwide. All other trademarks are property
   of their respective owners. </p>
</div>
</body>
</html>
